" AutoAlign.vim: a ftplugin for C
" Author:	Charles E. Campbell, Jr.  <NdrOchip@ScampbellPfamily.AbizM>-NOSPAM
" Date:		Jan 14, 2005
" Version:	5	NOT RELEASED
" GetLatestVimScripts: 884  1 :AutoInstall: AutoAlign.vim
" GetLatestVimScripts: 294  1 :AutoInstall: Align.vim
" GetLatestVimScripts: 1066 1 :AutoInstall: cecutil.vim
if exists("b:didautoalign_tex")
 finish
endif
let b:didautoalign_tex = 5
"DechoVarOn

" ---------------------------------------------------------------------
" Public Interface: AA toggles AutoAlign {{{1
com! -nargs=0 AA if exists("b:autoalign")|let b:autoalign= !b:autoalign|else|let b:autoalign= 0|endif|echo "AutoAlign is ".(b:autoalign? "on" : "off")

" ---------------------------------------------------------------------
"  overloading '=' to keep things lined up {{{1
ino <silent> \\ \\<ESC>:let b:autoalign_vekeep=&ve<bar>let &ve=""<bar>silent call <sid>AutoAlign_tex()<bar>let &ve=b:autoalign_vekeep<bar>norm! x<cr>i\

" ---------------------------------------------------------------------
"  AutoAlign_tex: decides when to use Align/AlignMaps's \t= for alignment
fun! s:AutoAlign_tex()
"  call Dfunc("AutoAlign_tex()")
  if exists("b:autoalign") && b:autoalign == 0
"   call Dret("AutoAlign_tex")
   return
  endif
  set lz

  if getline(".") =~ '^\([^&]*&\)\+[^&]*\\\{2}'
   let curposn   = SaveWinPosn()
   let curline   = line(".")
   let nopatline = search('^.*\(\\\\\)\@<!$\&^.','bW')
   call RestoreWinPosn(curposn)
   if exists("b:autoalign_tex") && line("'a") == b:autoalign_tex && b:autoalign_tex < curline && nopatline < line("'a")
"   	call Decho("autoalign multi")
	let atend= col(".") >= col("$") - 1
    exe "norm! i\<c-g>u\<esc>"
    exe "norm ".g:mapleader."tt$"
	if !atend
	 norm! h
	endif
   else
    let b:autoalign_tex= line(".")
    ka
"	call Decho("autoalign start")
   endif

  elseif exists("b:autoalign_tex")
   unlet b:autoalign_tex
"   call Decho("autoalign suspend")
  endif

  set nolz
"  call Dret("AutoAlign_tex")
endfun

" ---------------------------------------------------------------------
" vim: ts=4 fdm=marker
